import java.util.*;
import java.io.*;

class Calc {
	Deque<Integer> data = new LinkedList<>();
	void eval(String op){
		int b = data.removeLast();
		int a = data.removeLast();
		switch(op.charAt(0)){
			case '+':
				data.addLast(a+b);
				break;
			case '-':
				data.addLast(a-b);
				break;
			case '*':
				data.addLast(a*b);
				break;
			case '/':
				data.addLast(a/b);
				break;
			default:
				throw new UnsupportedOperationException();

		}
	}
	public static void main(String [] args){
		Calc mycalc = new Calc();
		Scanner s = new Scanner(System.in);
		System.out.println("Enter number, operation, or Ctl-D to exit");
		while(s.hasNext()){
			if(s.hasNextInt())
				mycalc.data.addLast(s.nextInt());
			else{
				try{
					mycalc.eval(s.next());
				}catch(NoSuchElementException e){
					System.out.println("ERROR! : Not enough elements in stack for operation!");
					return;
				}catch(UnsupportedOperationException e){
					System.out.println("ERROR! : Unknown operation!");
					return;
				}
			}
			System.out.println("Current state:");
			System.out.println(mycalc.data);
		}
	}
}
